unit ddmutil1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, Gauges, Buttons;

type
  _MEDIA_TYPE = (
    Unknown,                // Format is unknown
    F5_1Pt2_512,            // 5.25", 1.2MB,  512 bytes/sector
    F3_1Pt44_512,           // 3.5",  1.44MB, 512 bytes/sector
    F3_2Pt88_512,           // 3.5",  2.88MB, 512 bytes/sector 
    F3_20Pt8_512,           // 3.5",  20.8MB, 512 bytes/sector 
    F3_720_512,             // 3.5",  720KB,  512 bytes/sector
    F5_360_512,             // 5.25", 360KB,  512 bytes/sector
    F5_320_512,             // 5.25", 320KB,  512 bytes/sector 

    F5_320_1024,            // 5.25", 320KB,  1024 bytes/sector 
    F5_180_512,             // 5.25", 180KB,  512 bytes/sector
    F5_160_512,             // 5.25", 160KB,  512 bytes/sector
    RemovableMedia,         // Removable media other than floppy
    FixedMedia
    );

    MEDIA_TYPE = _MEDIA_TYPE;

  _DISK_GEOMETRY = record
   Cylinders : LARGE_INTEGER;
   MediaType : MEDIA_TYPE;
   TracksPerCylinder : DWORD;
   SectorsPerTrack : DWORD;
   BytesPerSector : DWORD;
   end;

 DISK_GEOMETRY = _DISK_GEOMETRY;

  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    ComboBox1: TComboBox;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    SpinEdit1: TSpinEdit;
    Gauge1: TGauge;
    EtatProgression: TLabel;
    SpeedButton1: TSpeedButton;
    CheckBox1: TCheckBox;
    Simuler: TButton;
    Verifier: TButton;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    Ecrire: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SimulerClick(Sender: TObject);
    procedure VerifierClick(Sender: TObject);
    procedure EcrireClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

const
    MEDIA_TYPE_str:array [1..12]of string= (
                       'Inconnu',
                       '5.25", 1.2Mo, 512 oct/sect',
                       '3.5", 1.44Mo, 512 oct/sect',
                       '3.5", 2.88Mo, 512 oct/sect',
                       '3.5", 20.8Mo, 512 oct/sect',
                       '3.5", 720Ko, 512 oct/sect',
                       '5.25", 360Ko, 512 oct/sect',
                       '5.25", 320Ko, 1024 oct/sect',
                       '5.25", 180Ko, 512 oct/sect',
                       '5.25", 160Ko, 512 oct/sect',
                       'Lecteur amovible (non disquette)',
                       'Lecteur fixe (disque dur)');

implementation

{$R *.dfm}
uses dateutils;
var i,j:integer;
    d:int64;
    dwreturned:dword;
    h:thandle;
    b:longbool;
    base,s,s2:string;
    DISKGEOMETRY:DISK_GEOMETRY;
    t:array of byte;
const tbase:array[0..1] of string=('\\.\PhysicalDrive','\\.\cdrom');
IOCTL_DISK_GET_DRIVE_GEOMETRY=458752;

procedure TForm1.Button1Click(Sender: TObject);
begin
  button1.Enabled:=false;
  memo1.Clear;
  combobox1.Clear;
  application.ProcessMessages;
for j:= 0 to 1 do
begin
  h:=0;
  i:=0;
  repeat
    s:=tbase[j]+inttostr(i);
    h:=CreateFile(pchar(s),0,0,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
    if h<>INVALID_HANDLE_VALUE
    then
    begin
      s2:=' ouverture avec succes !! : '+s;
      b:=DeviceIoControl(h,IOCTL_DISK_GET_DRIVE_GEOMETRY,nil,0,@DISKGEOMETRY,sizeof(DISKGEOMETRY),dwreturned,nil);
      closehandle(h);
      if b<>false then   with DISKGEOMETRY do
      begin
        d:=Cylinders.QuadPart*TracksPerCylinder*SectorsPerTrack*BytesPerSector;
        if (DISKGEOMETRY.MediaType=RemovableMedia) or checkbox1.Checked then
        combobox1.Items.Append(s);
        s2:=s2+#13+
        '           ----> Type     : '+media_type_str[ord(DISKGEOMETRY.MediaType)]+#13+
        '           ----> Capacit : '+inttostr((d div 1024) div 1024)+' Mo ('+inttostr(d)+' octets)'#13+
        '          ----> Parametre = ('+
        'Cyl:'+inttostr(Cylinders.QuadPart)+
        ' Piste/Cyl:'+inttostr(TracksPerCylinder)+
        ' Sect/Piste:'+inttostr(SectorsPerTrack)+
        ' Oct/Sect:'+inttostr(BytesPerSector)+
        ')';
      end;
      memo1.Lines.Text:=memo1.Lines.Text+s2+#13;
    end;
//    else
//      s2:='    * erreur d''ouverture de '+s
    inc(i);
  until {(i>10) or }(h=INVALID_HANDLE_VALUE);
end;
  button1.Enabled:=true;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if not(simuler.Enabled and verifier.Enabled and ecrire.Enabled and button2.Enabled) then exit;
  if checkbox2.Checked then simulerclick(sender) else ecrireclick(sender);
  if checkbox3.Checked then verifierclick(sender);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  button1.Enabled:=true;
  button2.Enabled:=true;
  Simuler.Enabled:=true;
  Verifier.Enabled:=true;
  Ecrire.Enabled:=true;
end;

procedure TForm1.SimulerClick(Sender: TObject);
var pf,tf,taillefich:LARGE_INTEGER;
    lerr,octetfait:dword;
    taillebuf:integer;
    e:int64;
    time1,time2:tdatetime;
begin
if not(simuler.Enabled and verifier.Enabled and ecrire.Enabled and button2.Enabled) then exit;
 setlength(t,0);
 if combobox1.Text='' then showmessage('Veuillez d''abort slectionner un disque amovible !') else
    begin
    if application.MessageBox('Cette opration va DETRUIRE (simulation) TOUT son contenue et sera IRRECUPERABLE !'+#13+
    'Etes vous sre ?','Effacement simul (lecture) COMPLET d''un disque amovible (R.A.Z, formattage de bas niveau) ',MB_OKCANCEL+MB_DEFBUTTON2+MB_ICONWARNING)=IDOK then
     begin
       showmessage('Dmarrage ... Prt  a simulation d''criture (lecture) !! ');
       s:=combobox1.Text;
       gauge1.Progress:=0;
       gauge1.ForeColor:=ClYellow;
       h:=CreateFile(pchar(s),GENERIC_READ+GENERIC_WRITE,FILE_SHARE_READ+FILE_SHARE_WRITE,
                     nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL+FILE_FLAG_WRITE_THROUGH+FILE_FLAG_NO_BUFFERING,0);
       Simuler.Enabled:=false;
       if h<>INVALID_HANDLE_VALUE then
       begin
         b:=DeviceIoControl(h,IOCTL_DISK_GET_DRIVE_GEOMETRY,nil,0,@DISKGEOMETRY,sizeof(DISKGEOMETRY),dwreturned,nil);
         if b<>false then   with DISKGEOMETRY do
         begin
           d:=Cylinders.QuadPart*TracksPerCylinder*SectorsPerTrack*BytesPerSector;
           if d<256*1024*1024 then
           taillebuf:=bytespersector*256 else
           taillebuf:=bytespersector*256*8;
           tf.QuadPart:=0;
           pf.QuadPart:=0;
           setlength(t,taillebuf);
           fillchar(t[0],taillebuf{length(t)},byte(spinedit1.Value));
//           tf.LowPart:=getfilesize(h,@tf.HighPart);
           tf.QuadPart:=d;
           taillefich.QuadPart:=0;
           pf.LowPart:=setfilepointer(h,pf.LowPart,@pf.HighPart,FILE_BEGIN);
           lerr:=getlasterror;
           e:=pf.QuadPart;
           octetfait:=taillebuf;
           time1:=now;
           while (octetfait=taillebuf) and (e<d) and (application.Terminated=false) and (speedbutton1.Down=false) do
           begin
             octetfait:=0;
             b:=readfile(h,t[0],taillebuf,octetfait,nil);
             time2:=now;if time1=time2 then time2:=time1+0.0001;
             pf.QuadPart:=pf.QuadPart+octetfait;
             gauge1.Progress:=trunc((pf.QuadPart/tf.QuadPart)*1000);
             EtatProgression.Caption:='Progression : '+#13+' -->'+inttostr(pf.QuadPart)+'/'
                                       +inttostr(tf.QuadPart)+' octets lues'+#13+
                                       inttostr(octetfait)+' octets dernirement effectus'+#13+
                                       inttostr(trunc(pf.QuadPart/(1000*secondspan(time1,time2))))+' Koctets/sec';
             if (b=false) or (octetfait<>taillebuf) then e:=d else
             e:=e+octetfait;
             application.ProcessMessages;
           end;
           speedbutton1.Down:=false;
           showmessage('ok!  taille : '+inttostr(tf.QuadPart)+' , position : '+inttostr(pf.QuadPart)+#13+'derniere erreur : '+
           inttostr(lerr));
{           pf.QuadPart:=tf.QuadPart+taillebuf*4;
           pf.LowPart:=setfilepointer(h,pf.LowPart,@pf.HighPart,FILE_BEGIN);
             octetfait:=0;
             b:=readfile(h,t,taillebuf,octetfait,nil); }
         end;
         closehandle(h);
       end;
       showmessage('Effacement Termin !! ');
       Simuler.Enabled:=true;
     end;
    end;
end;

procedure TForm1.VerifierClick(Sender: TObject);
var pf,tf,taillefich:LARGE_INTEGER;
    lerr,octetfait:dword;
    taillebuf:integer;
    e:int64;
    time1,time2:tdatetime;
    ignorererreur:boolean;
    i1,i2:integer;
    derniereerreur,nberreur,cmperreur,valerreur:integer;
begin
if not(simuler.Enabled and verifier.Enabled and ecrire.Enabled and button2.Enabled) then exit;
 setlength(t,0);
 if combobox1.Text='' then showmessage('Veuillez d''abort slectionner un disque amovible !') else
    begin
    if application.MessageBox('Cette opration va VERIFIER LA VIRGINITE du disque !'+#13+
    'S''arrter  la moindre erreur ?','Vrification de la virginit d''un disque amovible ',MB_YESNO+MB_DEFBUTTON2+MB_ICONWARNING)=IDYES then
     ignorererreur:=false else ignorererreur:=true;
     begin
       showmessage('Dmarrage ... Prt au test de virginit !! ');
       s:=combobox1.Text;
       gauge1.Progress:=0;
       gauge1.ForeColor:=ClLime;
       cmperreur:=spinedit1.Value;
       derniereerreur:=cmperreur;
       valerreur:=cmperreur;
       nberreur:=0;
       h:=CreateFile(pchar(s),GENERIC_READ+GENERIC_WRITE,FILE_SHARE_READ+FILE_SHARE_WRITE,
                     nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL+FILE_FLAG_WRITE_THROUGH+FILE_FLAG_NO_BUFFERING,0);
       Verifier.Enabled:=false;
       if h<>INVALID_HANDLE_VALUE then
       begin
         b:=DeviceIoControl(h,IOCTL_DISK_GET_DRIVE_GEOMETRY,nil,0,@DISKGEOMETRY,sizeof(DISKGEOMETRY),dwreturned,nil);
         if b<>false then   with DISKGEOMETRY do
         begin
           d:=Cylinders.QuadPart*TracksPerCylinder*SectorsPerTrack*BytesPerSector;
           if d<256*1024*1024 then
           taillebuf:=bytespersector*256 else
           taillebuf:=bytespersector*256*8;
           tf.QuadPart:=0;
           pf.QuadPart:=0;
           setlength(t,taillebuf);
           fillchar(t[0],taillebuf{length(t)},byte(spinedit1.Value));
//           tf.LowPart:=getfilesize(h,@tf.HighPart);
           tf.QuadPart:=d;
           taillefich.QuadPart:=0;
           pf.LowPart:=setfilepointer(h,pf.LowPart,@pf.HighPart,FILE_BEGIN);
           lerr:=getlasterror;
           e:=pf.QuadPart;
           octetfait:=taillebuf;
           time1:=now;
           while (octetfait=taillebuf) and (e<d) and (application.Terminated=false) and (speedbutton1.Down=false) do
           begin
             octetfait:=0;
             b:=readfile(h,t[0],taillebuf,octetfait,nil);
             for i1:= 0 to pred(octetfait) do
             begin
             derniereerreur:=valerreur;
               valerreur:=byte(t[i]);
               if valerreur<>cmperreur then inc(nberreur);
             end;
             time2:=now;if time1=time2 then time2:=time1+0.0001;
             pf.QuadPart:=pf.QuadPart+octetfait;
             gauge1.Progress:=trunc((pf.QuadPart/tf.QuadPart)*1000);
             EtatProgression.Caption:='Progression : '+#13+' -->'+inttostr(pf.QuadPart)+'/'
                                       +inttostr(tf.QuadPart)+' octets lues'+#13+
                                       inttostr(octetfait)+' octets dernirement effectus'+#13+
                                       inttostr(trunc(pf.QuadPart/(1000*secondspan(time1,time2))))+' Koctets/sec'+#13+
                                       inttostr(nberreur)+' erreur(s) trouve(s) de vrif.';
             if (b=false) or (octetfait<>taillebuf) or ((nberreur<>0) and (ignorererreur=false)) then e:=d else
             e:=e+octetfait;
             application.ProcessMessages;
           end;
           speedbutton1.Down:=false;
           showmessage('ok! cool. taille : '+inttostr(tf.QuadPart)+' , position : '+inttostr(pf.QuadPart)+#13+'derniere erreur : '+
           inttostr(lerr));
{           pf.QuadPart:=tf.QuadPart+taillebuf*4;
           pf.LowPart:=setfilepointer(h,pf.LowPart,@pf.HighPart,FILE_BEGIN);
             octetfait:=0;
             b:=readfile(h,t,taillebuf,octetfait,nil); }
         end;
         closehandle(h);
       end;
       showmessage('Effacement Termin !! ');
       Verifier.Enabled:=true;
     end;
    end;
end;

procedure TForm1.EcrireClick(Sender: TObject);
var pf,tf,taillefich:LARGE_INTEGER;
    lerr,octetfait:dword;
    taillebuf:integer;
    e:int64;
    time1,time2:tdatetime;
begin
if not(simuler.Enabled and verifier.Enabled and ecrire.Enabled and button2.Enabled) then exit;
 setlength(t,0);
 if combobox1.Text='' then showmessage('Veuillez d''abort slectionner un disque amovible !') else
    begin
    if application.MessageBox('Cette opration va DETRUIRE TOUT son contenue et sera IRRECUPERABLE !'+#13+
    'Etes vous sre ?','Effacement COMPLET d''un disque amovible (R.A.Z, formattage de bas niveau) ',MB_OKCANCEL+MB_DEFBUTTON2+MB_ICONWARNING)=IDOK then
     begin
       showmessage('Dmarrage ... Prt  l''ffacement !! ');
       s:=combobox1.Text;
       gauge1.Progress:=0;
       gauge1.ForeColor:=ClRed;
       h:=CreateFile(pchar(s),GENERIC_READ+GENERIC_WRITE,FILE_SHARE_READ+FILE_SHARE_WRITE,
                     nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL+FILE_FLAG_WRITE_THROUGH+FILE_FLAG_NO_BUFFERING,0);
       Ecrire.Enabled:=false;
       if h<>INVALID_HANDLE_VALUE then
       begin
         b:=DeviceIoControl(h,IOCTL_DISK_GET_DRIVE_GEOMETRY,nil,0,@DISKGEOMETRY,sizeof(DISKGEOMETRY),dwreturned,nil);
         if b<>false then   with DISKGEOMETRY do
         begin
           d:=Cylinders.QuadPart*TracksPerCylinder*SectorsPerTrack*BytesPerSector;
           if d<256*1024*1024 then
           taillebuf:=bytespersector*256 else
           taillebuf:=bytespersector*256*8;
           tf.QuadPart:=0;
           pf.QuadPart:=0;
           setlength(t,taillebuf);
           fillchar(t[0],taillebuf{length(t)},byte(spinedit1.Value));
//           tf.LowPart:=getfilesize(h,@tf.HighPart);
           tf.QuadPart:=d;
           taillefich.QuadPart:=0;
           pf.LowPart:=setfilepointer(h,pf.LowPart,@pf.HighPart,FILE_BEGIN);
           lerr:=getlasterror;
           e:=pf.QuadPart;
           octetfait:=taillebuf;
           time1:=now;
           while (octetfait=taillebuf) and (e<d) and (application.Terminated=false) and (speedbutton1.Down=false) do
           begin
             octetfait:=0;
             b:=writefile(h,t[0],taillebuf,octetfait,nil);
             time2:=now;if time1=time2 then time2:=time1+0.0001;
             pf.QuadPart:=pf.QuadPart+octetfait;
             gauge1.Progress:=trunc((pf.QuadPart/tf.QuadPart)*1000);
             EtatProgression.Caption:='Progression : '+#13+' -->'+inttostr(pf.QuadPart)+'/'
                                       +inttostr(tf.QuadPart)+' octets lues'+#13+
                                       inttostr(octetfait)+' octets dernirement effectus'+#13+
                                       inttostr(trunc(pf.QuadPart/(1000*secondspan(time1,time2))))+' Koctets/sec';
             if (b=false) or (octetfait<>taillebuf) then e:=d else
             e:=e+octetfait;
             application.ProcessMessages;
           end;
           speedbutton1.Down:=false;
           showmessage('ok! cool. taille : '+inttostr(tf.QuadPart)+' , position : '+inttostr(pf.QuadPart)+#13+'derniere erreur : '+
           inttostr(lerr));
{           pf.QuadPart:=tf.QuadPart+taillebuf*4;
           pf.LowPart:=setfilepointer(h,pf.LowPart,@pf.HighPart,FILE_BEGIN);
             octetfait:=0;
             b:=readfile(h,t,taillebuf,octetfait,nil); }
         end;
         closehandle(h);
       end;
       showmessage('Effacement Termin !! ');
       Ecrire.Enabled:=true;
     end;
    end;
end;

end.
